#include <Servo_megaTinyCore.h>
Servo s1;
String x;
int servoval;
String data;
char d1;
int redPin=7;
int greenPin=0;
int bluePin=1;
int redValue,greenValue,blueValue;
unsigned long  lastDebounceTime = 0;
unsigned long debounceDelay = 5;
int buttonPin=8;
int buttonState;
int lastButtonState = HIGH;

void setup() {
   Serial.begin(9600);
   pinMode(6,OUTPUT);
   pinMode(redPin,OUTPUT);
   pinMode(greenPin,OUTPUT);
   pinMode(bluePin,OUTPUT);
   pinMode(buttonPin,INPUT_PULLUP);
   s1.attach(10);
}

void loop() {
 /*if(Serial.available()){
  data=Serial.readString();
  d1=data.charAt(0);
  if(d1 == 'f'){
    digitalWrite(13,LOW);

  }
  else if(d1=='n'){
    digitalWrite(13,HIGH);
  }

 }*/
 if(Serial.available()){
  data=Serial.readString();
  d1=data.charAt(0);
  switch (d1){
    case 'n':
    digitalWrite(6,HIGH);
    break;
    case 'f':
    digitalWrite(6,LOW);
    break;
    case 's':
    x=data.substring(1);
    servoval=x.toInt();
    s1.write(servoval);
    delay(100);
    break;
    case 'R':
    x=data.substring(1);
    redValue=x.toInt();
    analogWrite(redPin,redValue);
    break;
    case 'G':
    x=data.substring(1);
    greenValue=x.toInt();
    analogWrite(greenPin,greenValue);
    break;
    case 'B':
    x=data.substring(1);
    blueValue=x.toInt();
    analogWrite(bluePin,blueValue);
    break;
  }
 }
   HandleButton();
   HandlePot();

}
void HandleButton(void){
int reading=digitalRead(buttonPin);
if(reading!=lastButtonState){
  lastDebounceTime= millis();
}
if((millis() - lastDebounceTime) > debounceDelay){
  if(reading!= buttonState){
     buttonState= reading;
     if(buttonState==HIGH){
      Serial.println("p");
     }
  }
  }
  lastButtonState = reading;
  }
  void HandlePot(void){
    String val;
    static int old=0;
    int current=0,upper,lower;
    current= analogRead(10);
    upper=current + 2; 
    lower = current -2 ;
    if(current!=old){
      if((old<=lower)||(old>=upper)){
        val=String(current);
        Serial.println(val);
        old=current;
      }
    }
  }

